//==============================================================================
//	
//	Copyright (c) 2002-
//	Authors:
//	* Dave Parker <david.parker@comlab.ox.ac.uk> (University of Oxford)
//	* Aistis Simaitis <aistis.simaitis@cs.ox.ac.uk> (University of Oxford)
//	
//------------------------------------------------------------------------------
//	
//	This file is part of PRISM.
//	
//	PRISM is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//	
//	PRISM is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//	
//	You should have received a copy of the GNU General Public License
//	along with PRISM; if not, write to the Free Software Foundation,
//	Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//	
//==============================================================================

//==============================================================================
//
// Copyright (c) 2015
// New file written (on the basis of SMGRewardsSimple.java) by Benjamin Monmege 
// <benjamin.monmege@ulb.ac.be> (Université libre de Bruxelles)
// 
//==============================================================================

package explicit.rewards;

import java.util.List;


/**
 * Simple explicit-state storage of rewards for a Game.
 */
public class GameRewardsSimple extends MDPRewardsSimple implements GameRewards {


	/**
	 * Constructor: all zero rewards.
	 * @param numStates Number of states
	 */
	public GameRewardsSimple(int numStates)
	{
		super(numStates);
	}
	
	/**
	 * Copy constructor
	 * @param rews Rewards to copy
	 */
	public GameRewardsSimple(SMGRewardsSimple rews)
	{
		super(rews);
	}

	@Override
	public MDPRewards buildMDPRewards() {
		return this;
	}

	@Override
	public double getNestedTransitionReward(int s, int i, int j) {
		// TODO Auto-generated method stub
		return 0;
	}
	
	public double getGreatestAbsoluteReward()
	{
		double weight = 0;
		int s, i;
		List<Double> list;
		if (transRewards == null)
			return 0;
		for (s=0; s<transRewards.size(); s++) {
			list = transRewards.get(s);
			if (list != null)
			{
				for (i=0; i<list.size(); i++) {
					if (java.lang.Math.abs(list.get(i)) > weight) 
						weight = java.lang.Math.abs(list.get(i));
				}
			}
		}
		return weight;
	}
	
}
